/*******************************************************************************
*  skI2Clib - hQb֐Cu(PUrbglbtp)                       *
*             ̃CuI2CfoCX(RTC/EEPROM)Ɛڑsׂ̊֐W  *
*                                                                              *
*    _MI2CxInterrupt- hQb֘Ã}X^[荞ݏ                         *
*    InitI2C_Master - hQbʐM̃}X^[[hŏs             *
*    I2C_Start      - X[uɃX^[gRfBV𔭍s鏈           *
*    I2C_rStart     - X[uɃs[gEX^[gRfBV𔭍s鏈 *
*    I2C_Stop       - X[uɃXgbvRfBV𔭍s鏈           *
*    I2C_Send       - X[uɃf[^PoCgM鏈                   *
*    I2C_Receive    - X[uf[^PoCgM鏈                 *
*                                                                              *
*    I2C_SlaveRead  - X[ũfoCXw̃f[^ǂݍޏ     *
*    I2C_SlaveWrite - X[ũfoCXɎw̃f[^ޏ       *
*                                                                              *
*    FSDA/SCLs͕KufW^̓svɐݒsĉB         *
*          ʐMNbN100/400KHzł̏łB                            *
*          }`}X^[ɃoXՓ˂ꍇ́A"I2C_Start"đ *
*          I2C2𗘗pꍇ́AskI2Clib.h"#define I2C_MSSP2_USE"錾 *
*          "skI2Clib.h""#define FCY 60000000"LqĂA              *
*          120MHz(60MIPS)ȊOCPUNbNɂl͏܂傤B         *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2015-07-27  ޒH[(ނ)  Create                            *
*  2.00    2016-07-15  ޒH[(ނ)  foCX̃WX^Ǐ֐ǉ*
*  2.01    2017-02-22  ޒH[(ނ)  Rgǉ                      *
*  3.00    2019-01-08  ޒH[(ނ)  FCYŒʐMxIɐݒŕύX *
*                                            PIC24FɂΉ                *
* ============================================================================ *
*  PIC24E(24EP256MC202) PIC24F(24FJ64GB002)                                    *
*  MPLAB X(v4.10)                                                              *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <xc.h>
#include "skI2Clib.h"

int AckCheck ;           // 肩ACK҂ptOϐ
int CollisionCheck ;     // ̃}X^[Ƃ̃oXՓˌoptOϐ

// AChԂ̃`FbN
// ACKEN RCEN PEN RSEN SEN TRSTAT RBF TBF SĂOȂnj
void I2C_IdleCheck(unsigned int mask)
{
     while (( I2C_CON & 0x1F ) | (I2C_STAT & mask)) ;
}
/*******************************************************************************
*  _MI2CxInterrupt( void )                                                     *
*    hQb(}X^[[h)֘Å荞ݏ                                  *
*******************************************************************************/
#ifdef  I2C_MSSP2_USE
void __attribute__((interrupt, no_auto_psv)) _MI2C2Interrupt(void)
#else
void __attribute__((interrupt, no_auto_psv)) _MI2C1Interrupt(void)
#endif
{
     if (AckCheck == 1) AckCheck = 0 ;
     if (I2C_STAT_BCL == 1) CollisionCheck = 1 ;  // oX̏Փ˂
     I2C_MIF = 0 ;                                // tONA
}
/*******************************************************************************
*  InitI2C_Master(speed)                                                       *
*    hQbʐM̃}X^[[hŏs                              *
*                                                                              *
*    speed : I2C̒ʐMxw(0=100KHz 1=400KHz)                            *
*                                                                              *
*   )LNbN̂ݑΉÃNbNI2CxBRGύXĉ             *
*                 PIC24F                    PIC24E                             *
*     FCY     4MHz 8MHz 16MHz | 10MHz 20MHz 30MHz 40MHz  60MHz   70MHz         *
*    100KHz   0x27 0x4E 0x9D  | 0x0B2 0x0C5 0x128 0x18B (0x1FF܂ł̐ݒƂȂ)*
*    400kHz   0x09 0x12 0x25  | 0x017 0x02F 0x047 0x05F  0x08F   0x0A7         *
*    ̒lAۂ͒Kv                                          *
*******************************************************************************/
void InitI2C_Master(int speed)
{
     I2C_CON = 0b1000001000000000 ;// X[[gOFF(}X^[@\̂ݐݒ)
     if (speed == I2C_SPEED_100KHZ) {

#if defined(__PIC24F__)
#if FCY == 4000000
          I2C_BRG = 0x27 ;         // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x09 ;         // I2CʐMx400KHz
#elif FCY == 8000000
          I2C_BRG = 0x4E ;         // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x12 ;         // I2CʐMx400KHz
#elif FCY == 16000000
          I2C_BRG = 0x9D ;         // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x25 ;         // I2CʐMx400KHz
#else  // Fosc̏ꍇ͂ɎŐݒs
          I2C_BRG = 0x?? ;         // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x?? ;         // I2CʐMx400KHz
#endif
#endif

#if defined(__PIC24E__)
#if FCY == 10000000
          I2C_BRG = 0x0B2 ;        // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x017 ;        // I2CʐMx400KHz
#elif FCY == 20000000
          I2C_BRG = 0x0C5 ;        // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x02F ;        // I2CʐMx400KHz
#elif FCY == 30000000
          I2C_BRG = 0x128 ;        // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x047 ;        // I2CʐMx400KHz
#elif FCY == 40000000
          I2C_BRG = 0x18B ;        // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x05F ;        // I2CʐMx400KHz
#elif FCY == 60000000
          I2C_BRG = 0x1FF ;        // I2CʐMx100KHz(60MHzȏ112KHzʂɂȂ)
     } else {
          I2C_BRG = 0x08F ;        // I2CʐMx400KHz
#elif FCY == 70000000
          I2C_BRG = 0x1FF ;        // I2CʐMx100KHz(60MHzȏ112KHzʂɂȂ)
     } else {
          I2C_BRG = 0x0A7 ;        // I2CʐMx400KHz
#else  // Fosc̏ꍇ͂ɎŐݒs
          I2C_BRG = 0x??? ;        // I2CʐMx100KHz
     } else {
          I2C_BRG = 0x??? ;        // I2CʐMx400KHz
#endif
#endif

          I2C_CON_DISSLW = 0 ;     // X[[gONɐݒ肷
     }

     I2C_MIE = 1 ;                 // I2C}X^[݂
     I2C_MIP = 5 ;                 // I2C}X^[ݗD惌x(0-7)ݒ肷
     I2C_MIF = 0 ;                 // I2C}X^[݃tONA
}
/*******************************************************************************
*  ans = I2C_Start(adrs,rw)                                                    *
*    X[uɃX^[gRfBV𔭍s鏈                            *
*                                                                              *
*    adrs : X[ũAhXw肵܂                                     *
*    rw   : X[uɑ΂铮̎w܂                                 *
*           0=X[uɏ݂Ȃv@1=X[uɑMȂv         *
*    ans  : 0=                                                             *
*           1=ُ(肩ACKԂĂȂ) -1=̃}X^[Ƃ̃oXՓ˔  *
*******************************************************************************/
int I2C_Start(int adrs,int rw)
{
     CollisionCheck = 0 ;
     // X^[g(START CONDITION)
     I2C_IdleCheck(0x4003) ;
     I2C_CON_SEN = 1 ;
     // [X[ũAhX]𑗐M
     I2C_IdleCheck(0x4003) ;
     if (CollisionCheck == 1) return -1 ;
     AckCheck = 1 ;
     I2C_TRN = (char)((adrs<<1)+rw) ;   // AhX + R/W𑗐M
     while (AckCheck) ;                 // 肩ACKԓ҂
     if (CollisionCheck == 1) return -1 ;
     return I2C_STAT_ACKSTAT ;
}
/*******************************************************************************
*  ans = I2C_rStart(adrs,rw)                                                   *
*    X[uɃs[gEX^[gRfBV𔭍s鏈                  *
*                                                                              *
*    adrs : X[ũAhXw肵܂                                     *
*    rw   : X[uɑ΂铮̎w܂                                 *
*           0=X[uɏ݂Ȃv@1=X[uɑMȂv         *
*    ans  : 0=                                                             *
*           1=ُ(肩ACKԂĂȂ) -1=̃}X^[Ƃ̃oXՓ˔  *
*******************************************************************************/
int I2C_rStart(int adrs,int rw)
{
     CollisionCheck = 0 ;
     // s[gEX^[g(REPEATED START CONDITION)
     I2C_IdleCheck(0x4003) ;
     I2C_CON_RSEN = 1 ;
     // [X[ũAhX]𑗐M
     I2C_IdleCheck(0x4003) ;
     if (CollisionCheck == 1) return -1 ;
     AckCheck = 1 ;
     I2C_TRN = (char)((adrs<<1)+rw) ;   // AhX + R/W𑗐M
     while (AckCheck) ;                 // 肩ACKԓ҂
     if (CollisionCheck == 1) return -1 ;
     return I2C_STAT_ACKSTAT ;
}
/*******************************************************************************
*  ans = I2C_Stop()                                                            *
*    X[uɃXgbvRfBV𔭍s鏈                            *
*    ans  :  0=                                                            *
*           -1=̃}X^[Ƃ̃oXՓ˔                                    *
*******************************************************************************/
int I2C_Stop()
{
     CollisionCheck = 0 ;
     // Xgbv(STOP CONDITION)
     I2C_IdleCheck(0x4003) ;
     I2C_CON_PEN = 1 ;
     if (CollisionCheck == 1) return -1 ;
     else                     return  0 ;
}
/*******************************************************************************
*  ans = I2C_Send(dt)                                                          *
*    X[uɃf[^PoCgM鏈                                    *
*                                                                              *
*    dt  : Mf[^w肵܂                                          *
*    ans  : 0=                                                             *
*           1=ُ(肩ACKԂĂȂNOACKԂ)                 *
*          -1=̃}X^[Ƃ̃oXՓ˔                                     *
*******************************************************************************/
int I2C_Send(char dt)
{
     CollisionCheck = 0 ;
     I2C_IdleCheck(0x4001) ;
     if (CollisionCheck == 1) return -1 ;
     AckCheck = 1 ;
     I2C_TRN = dt ;                // f[^𑗐M
     while (AckCheck) ;            // 肩ACKԓ҂
     if (CollisionCheck == 1) return -1 ;
     return I2C_STAT_ACKSTAT ;
}
/*******************************************************************************
*  ans = I2C_Receive(ack)                                                      *
*    X[uf[^PoCgM鏈                                  *
*                                                                              *
*    ack  : X[uւ̕ԓf[^w肵܂                                 *
*           0:ACKԂ@1:NOACKԂ(Mf[^ŌȂ1)                  *
*    ans  : Mf[^Ԃ                                               *
*           -1=̃}X^[Ƃ̃oXՓ˔                                    *
*******************************************************************************/
int I2C_Receive(int ack)
{
     int dt ;

     CollisionCheck = 0 ;
     I2C_IdleCheck(0x4002) ;
     I2C_CON_RCEN = 1 ;            // M
     // M҂
     while( (I2C_STAT_RBF != 1) | (I2C_CON_RCEN != 0) ) ;
     if (CollisionCheck == 1) return -1 ;
     dt = I2C_RCV ;                // f[^̎M
     I2C_IdleCheck(0x2) ;
     if (CollisionCheck == 1) return -1 ;
     I2C_CON_ACKDT = ack ;         // ACKf[^̃Zbg
     I2C_CON_ACKEN = 1 ;           // ACKf[^Ԃ
     return dt ;
}
/*******************************************************************************
*  ans = I2C_SlaveRead(slv_adrs,reg_adrs,*data,kosu)                           *
*  X[ũfoCXw̃f[^ǂݍޏ                        *
*  }`}X^[ɑΉĂ܂B                                            *
*                                                                              *
*    slv_adrs : X[ũfoCXAhXw肵܂(7bitŎw)             *
*    reg_adrs : Ǐof[^̃WX^[AhXw肵܂                   *
*               AIɓǏoꍇ́AǏoWX^[̐擪AhXw     *
*    *data    : Ǐof[^̊i[w肵܂                             *
*    kosu     : Ǐof[^̃oCgw肵܂                             *
*    ans      : 0=@1=ُ(肩ACKԂĂȂ)                      *
*              -1=̃}X^[Ƃ̃oXՓ˂ăgCI[o[           *
*******************************************************************************/
int I2C_SlaveRead(int slv_adrs,char reg_adrs,unsigned char *data,char kosu)
{
     int  ans , i , ack , j ;

     for (j=0 ; j<BUS_COLLISION_RETRY ; j++) {
          ans = I2C_Start(slv_adrs,RW_0);              // X^[gRfBV𔭍s
          if (ans == 0) {
               I2C_Send(reg_adrs) ;                    // WX^AhXw
               ans = I2C_rStart(slv_adrs,RW_1) ;       // s[gEX^[gRfBV𔭍s
               if (ans == 0) {
                    for (i=1 ; i<=kosu ; i++) {
                         if (i==kosu) ack = NOACK ;
                         else         ack = ACK ;
                         *data = I2C_Receive(ack);     // wǂݏo(M)
                         data++ ;
                    }
               }
          }
          I2C_Stop() ;                                 // XgbvRfBV𔭍s
          if (ans != -1) break ;                       // oX̏ՓˈȊOȂI
          else {
               __delay_ms(100) ;                       // oX̏Փ˂100msɃgC
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = I2C_SlaveWrite(slv_adrs,reg_adrs,*data,kosu)                          *
*  X[ũfoCXɎw̃f[^ޏ                          *
*  }`}X^[ɑΉĂ܂B                                            *
*                                                                              *
*    slv_adrs : X[ũfoCXAhXw肵܂(7bitŎw)             *
*    reg_adrs : of[^̃WX^[AhXw肷                     *
*               AIɏoꍇ́AoWX^[̐擪AhXw     *
*    *data    : of[^̊i[w肷                                 *
*    kosu     : of[^̃oCgw肷                               *
*    ans      : 0=@1=ُ(肩ACKԂĂȂ)                      *
*              -1=̃}X^[Ƃ̃oXՓ˂ăgCI[o[           *
*******************************************************************************/
int I2C_SlaveWrite(int slv_adrs,char reg_adrs,unsigned char *data,char kosu)
{
     int  ans , i , j ;

     for (j=0 ; j<BUS_COLLISION_RETRY ; j++) {
          ans = I2C_Start(slv_adrs,RW_0);         // X^[gRfBV𔭍s
          if (ans == 0) {
               I2C_Send(reg_adrs) ;               // WX^AhXw
               for (i=0 ; i<kosu ; i++) {
                    I2C_Send(*data) ;             // w(M)
                    data++ ;
               }
          }
          I2C_Stop() ;                            // XgbvRfBV𔭍s
          if (ans != -1) break ;                  // oX̏ՓˈȊOȂI
          else {
               __delay_ms(100) ;                  // oX̏Փ˂100msɃgC
          }
     }
     return ans ;
}
